XIncludeFile "d:\pprojekte\gemeinsam_pb\Gemeinsam.pb"
XIncludeFile "d:\pprojekte\gemeinsam_pb\LeseSchreibeINI.pb"


Enumeration
  #frmHaupt
EndEnumeration

Enumeration
  #mnu_Haupt
  #mnu_Laden
  #mnu_Speichern
  #mnu_Beenden
  #mnu_Com1
  #mnu_Com2
  #mnu_Com3
  #mnu_Com4
  #mnu_Hilfe
EndEnumeration
;
Enumeration
  #frmHaupt_l1
  #frmHaupt_l0
  #frmHaupt_l2
  #frmHaupt_l3
  #frmHaupt_l4
  #frmHaupt_txtAdresse
  #frmHaupt_cmbBank
  #frmHaupt_chkBankLoeschen
  #frmHaupt_txtBytes
  #frmHaupt_txtDatenSchreiben
  #frmHaupt_txtDatenLesen
  #frmHaupt_cmdLesen
  #frmHaupt_cmdSchreiben1
  #frmHaupt_cmdSchreiben2
  #frmHaupt_cmdSchreiben3
EndEnumeration

Global Kommpara.s, Ereignis.l

#Falsch=0
#Wahr=-1

*EmpfangsPuffer=AllocateMemory(512)

Procedure.l GetGadgetCursorPos(Gadget) 
  SendMessage_(GadgetID(Gadget),#EM_GETSEL,@Min,@Max) 
  ProcedureReturn Max 
EndProcedure 

Procedure.l FindeZeichenImSpeicher(*Speicher,Finde.c,Laenge.l)
  Protected i.l, a.c, z.l
  z=-1
  For i=0 To Laenge-1
      CopyMemory(*Speicher+i,@c,1)
      If c=Finde
         ProcedureReturn i
      EndIf
  Next 
  ProcedureReturn z
EndProcedure

Procedure Einstellungen(LesenSchreiben.l)
   Protected datei.s, x.l, y.l, dsk_br.l, dsk_ho.l
   Shared KommPara
   datei=app_path()+"v24spk.ini"
   ExamineDesktops()
   dsk_br=DesktopWidth(0)
   dsk_ho=DesktopHeight(0)
   Select LesenSchreiben
      Case 0  ;Lesen
         ;Fensterposition
         x=Val(GetItem("Fenster","X",datei))
         y=Val(GetItem("Fenster","Y",datei))
         If x<0 Or x>dsk_br-200:x=(dsk_br-WindowWidth(#frmHaupt))/2:EndIf
         If y<0 Or y>dsk_ho-200:y=(dsk_ho-WindowHeight(#frmHaupt))/2:EndIf
         ResizeWindow(#frmHaupt, x, y, #PB_Ignore , #PB_Ignore )
         ;serielle Schnittstelle
         SetMenuItemState(#mnu_Haupt,#mnu_Com1,0) 
         SetMenuItemState(#mnu_Haupt,#mnu_Com2,0) 
         SetMenuItemState(#mnu_Haupt,#mnu_Com3,0) 
         SetMenuItemState(#mnu_Haupt,#mnu_Com4,0) 
         KommPara=UCase(GetItem("Kommunikation","COM",datei))
         If KommPara="COM1":SetMenuItemState(#mnu_Haupt,#mnu_Com1,1):ProcedureReturn:EndIf
         If KommPara="COM2":SetMenuItemState(#mnu_Haupt,#mnu_Com2,1):ProcedureReturn:EndIf
         If KommPara="COM3":SetMenuItemState(#mnu_Haupt,#mnu_Com3,1):ProcedureReturn:EndIf
         If KommPara="COM4":SetMenuItemState(#mnu_Haupt,#mnu_Com4,1):ProcedureReturn:EndIf
         KommPara="COM1"
         SetMenuItemState(#mnu_Haupt,#mnu_Com1,1):
      Case 1 ;Schreiben
         ;Fensterposition
         PutItem("Fenster","X",Str(WindowX(#frmHaupt)),datei)
         PutItem("Fenster","Y",Str(WindowY(#frmHaupt)),datei)
         ;serielle Schnittstelle
         PutItem("Kommunikation","COM",Kommpara,datei)
   EndSelect
EndProcedure

Procedure SetzeKommandoModus(HCom.l)
  Protected Puffer.s
  Puffer = "K"
  WriteSerialPortData(Hcom,@Puffer,Len(Puffer))
  Delay(50)
EndProcedure

Procedure.s WarteAufEnde(HCom.l)
  Shared *EmpfangsPuffer
  Protected Anzahl.w, tmp.s, tmp2.s, i.w, zae.w
  tmp=""
  tmp2=""
  Repeat
    Anzahl=AvailableSerialPortInput(Hcom)
    If Anzahl>0
       Anzahl=ReadSerialPortData(Hcom,*EmpfangsPuffer,Anzahl)
       tmp=tmp+PeekS(*EmpfangsPuffer,Anzahl)
       If FindString(tmp,Chr(13)+Chr(10),1)
          Anzahl=Len(tmp)-2
          If Anzahl>32
             zae=0
             For i=1 To Anzahl
                 zae=zae+1
                 tmp2=tmp2+Mid(tmp,i,1)
                 If zae=32
                    tmp2=tmp2+Chr(13)+Chr(10)
                    zae=0
                 EndIf
             Next
             tmp=tmp2
          EndIf       
          Break
       EndIf
    EndIf
    WaitWindowEvent(100)
  ForEver                                                
  ProcedureReturn tmp
EndProcedure

Procedure PruefeGeraet()
   Protected Puffer.s, a.l, HCom
   HCom=OpenSerialPort(#PB_Any, KommPara, 4800, #PB_SerialPort_NoParity, 8, 2, #PB_SerialPort_NoHandshake, 512, 512)
   If Hcom 
      SetzeKommandoModus(HCom)
      Puffer.s="B?"+Chr(13)
      WriteSerialPortData(Hcom,@Puffer,Len(Puffer))
      Delay(300)
      If AvailableSerialPortInput(Hcom)>0
         Puffer=WarteAufEnde(Hcom)
         Puffer=ReplaceString(Puffer,Chr(13)+Chr(10),"")
         SetGadgetState(#frmHaupt_cmbBank,Val(Puffer))
         Puffer.s="A?"+Chr(13)
         WriteSerialPortData(Hcom,@Puffer,Len(Puffer))
         Puffer=WarteAufEnde(Hcom)
         Puffer=ReplaceString(Puffer,Chr(13)+Chr(10),"")
         SetGadgetText(#frmHaupt_txtAdresse,Puffer)
         a=0
      Else
         a=1
      EndIf
      CloseSerialPort(Hcom)
   Else
      a=0
   EndIf
   DisableGadget(#frmHaupt_cmdSchreiben1, a)
   DisableGadget(#frmHaupt_cmdSchreiben2, a)
   DisableGadget(#frmHaupt_cmdSchreiben3, a)
   DisableGadget(#frmHaupt_cmdLesen, a)
EndProcedure



If LoadFont(0,"Courier New",8)
   SetGadgetFont(#PB_Default, FontID(0))
EndIf


If OpenWindow(#frmHaupt, 282, 128, 420, 465, " V.24 Speicherkasten",  #PB_Window_SystemMenu | #PB_Window_TitleBar )
   If CreateGadgetList(WindowID(#frmHaupt))
      TextGadget(#frmHaupt_l1, 15, 55, 100, 15, "Speicherbank:")
      TextGadget(#frmHaupt_l0, 15, 25, 100, 15, "Adresse:")
      TextGadget(#frmHaupt_l2, 15, 85, 100, 15, "Daten (Schreiben):")
      TextGadget(#frmHaupt_l3, 15, 115, 100, 15, "Anzahl Bytes:")
      TextGadget(#frmHaupt_l4, 15, 145, 100, 15, "Daten (Lesen):")
      StringGadget(#frmHaupt_txtAdresse, 130, 20, 40, 20, "0800")
      ComboBoxGadget(#frmHaupt_cmbBank, 130, 50, 40, 100)
      CheckBoxGadget(#frmHaupt_chkBankLoeschen, 180, 52, 70, 20,"Lschen")
      StringGadget(#frmHaupt_txtDatenSchreiben, 130, 80, 120, 20, "0011223344556677")
      StringGadget(#frmHaupt_txtBytes, 130, 110, 40, 20, "16",#PB_String_Numeric)
      EditorGadget(#frmHaupt_txtDatenLesen, 130, 145, 275, 290, #PB_String_ReadOnly)
      ButtonGadget(#frmHaupt_cmdSchreiben1, 300, 20, 105, 20, "Schreiben")
      ButtonGadget(#frmHaupt_cmdSchreiben2, 300, 50, 105, 20, "Schreiben")
      ButtonGadget(#frmHaupt_cmdSchreiben3, 300, 80, 105, 20, "Schreiben")
      ButtonGadget(#frmHaupt_cmdLesen, 300, 110, 105, 20, "Lesen")
      SendMessage_(GadgetID(#frmHaupt_txtAdresse), #EM_LIMITTEXT, 4, 0) 
      SendMessage_(GadgetID(#frmHaupt_txtBytes), #EM_LIMITTEXT, 3, 0) 
      SendMessage_(GadgetID(#frmHaupt_txtDatenSchreiben), #EM_LIMITTEXT, 16, 0) 
      AddGadgetItem (#frmHaupt_cmbBank,-1,"0")
      AddGadgetItem (#frmHaupt_cmbBank,-1,"1")
      AddGadgetItem (#frmHaupt_cmbBank,-1,"2")
      AddGadgetItem (#frmHaupt_cmbBank,-1,"3")
      AddGadgetItem (#frmHaupt_cmbBank,-1,"4")
      AddGadgetItem (#frmHaupt_cmbBank,-1,"5")
      AddGadgetItem (#frmHaupt_cmbBank,-1,"6")
      AddGadgetItem (#frmHaupt_cmbBank,-1,"7")
      SetGadgetState(#frmHaupt_cmbBank,0)
   EndIf

   If CreateMenu(#mnu_Haupt, WindowID(#frmHaupt))
      MenuTitle("Programm")
         ;MenuItem(#mnu_Laden, "Laden")
         ;MenuItem(#mnu_Speichern, "Speichern")
         ;MenuBar()
         MenuItem(#mnu_Beenden, "Programm beenden")
      MenuTitle("Schnittstelle")
         MenuItem(#mnu_Com1, "COM1")
         MenuItem(#mnu_Com2, "COM2")
         MenuItem(#mnu_Com3, "COM3")
         MenuItem(#mnu_Com4, "COM4")
   EndIf

   ;Programmeinstellungen laden
   Einstellungen(0)

   Hcom.l=0

   ;Ist Gert angeschlossen?
   PruefeGeraet()

   Repeat
       Ereignis = WaitWindowEvent()
       Select Ereignis
         Case #PB_Event_Menu

             Select EventMenu()
                Case #mnu_Com1
                   SetMenuItemState(#mnu_Haupt,#mnu_Com1,1) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com2,0) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com3,0) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com4,0) 
                   KommPara.s = "COM1"
                   ;Ist Gert angeschlossen?
                   PruefeGeraet()
                Case #mnu_Com2
                   SetMenuItemState(#mnu_Haupt,#mnu_Com1,0) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com2,1) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com3,0) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com4,0) 
                   KommPara.s = "COM2"
                   ;Ist Gert angeschlossen?
                   PruefeGeraet()
                Case #mnu_Com3
                   SetMenuItemState(#mnu_Haupt,#mnu_Com1,0) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com2,0) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com3,1) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com4,0) 
                   KommPara.s = "COM3"
                   ;Ist Gert angeschlossen?
                   PruefeGeraet()
                Case #mnu_Com4
                   SetMenuItemState(#mnu_Haupt,#mnu_Com1,0) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com2,0) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com3,0) 
                   SetMenuItemState(#mnu_Haupt,#mnu_Com4,1) 
                   KommPara.s = "COM4"
                   ;Ist Gert angeschlossen?
                   PruefeGeraet()
                Case #mnu_Laden
                Case #mnu_Speichern
                Case #mnu_Beenden
                   Quit=1
                Case #mnu_Hilfe
             EndSelect
         Case  #PB_Event_CloseWindow
             Quit = 1
         Case #PB_Event_Gadget
             WelchesGadget.l=EventGadget()
             If GadgetType(WelchesGadget)  = #PB_GadgetType_String
                If EventType()=#PB_EventType_Focus            
                   SendMessage_(GadgetID(WelchesGadget),#EM_SETSEL,0,-1) 
                EndIf
             EndIf
             Select WelchesGadget
                Case #frmHaupt_chkBankLoeschen
                   DisableGadget(#frmHaupt_cmbBank,GetGadgetState(#frmHaupt_chkBankLoeschen))
                   ;Beep_(400,50)
                Case #frmHaupt_txtAdresse,#frmHaupt_txtDatenSchreiben  ;
                   If EventType()=#PB_EventType_Change
                      c.l=GetGadgetCursorPos(WelchesGadget)
                      a.s=GetGadgetText(WelchesGadget)
                      b.s=""
                      d.l=Len(a)
                      If d>0
                         For i=1 To d
                             Select Asc(Mid(a,i,1))
                                 Case Asc("0") To Asc("9")
                                    b=b+Mid(a,i,1)
                                 Case Asc("a") To Asc("f")
                                    b=b+Mid(a,i,1)
                                 Case Asc("A") To Asc("F")
                                    b=b+Mid(a,i,1)
                                 Default
                                    c=c-1
                             EndSelect
                         Next       
                         SetGadgetText(WelchesGadget,b)
                         c=c+1
                         SendMessage_(GadgetID(WelchesGadget),#EM_SETSEL,c-1,c-1)
                       ;-----
                      EndIf
                   EndIf 
                Case #frmHaupt_cmdSchreiben1 To #frmHaupt_cmdSchreiben3
                   HCom=OpenSerialPort(#PB_Any, KommPara, 4800, #PB_SerialPort_NoParity, 8, 2, #PB_SerialPort_NoHandshake, 512, 512)
                   If Hcom 
                      SetzeKommandoModus(HCom)
                      Select WelchesGadget
                         Case #frmHaupt_cmdSchreiben1
                            Puffer.s = GetGadgetText(#frmHaupt_txtAdresse)
                            Puffer=RSet(Puffer, 4, "0")     
                            Puffer="AS"+Puffer+Chr(13)
                         Case #frmHaupt_cmdSchreiben2
                            If GetGadgetState(#frmHaupt_chkBankLoeschen)=1
                               Puffer="BL"+Chr(13)
                            Else
                               Puffer.s = GetGadgetText(#frmHaupt_cmbBank)
                               Puffer="BS"+Puffer+Chr(13)
                            EndIf
                         Case #frmHaupt_cmdSchreiben3
                            Puffer.s = GetGadgetText(#frmHaupt_txtDatenSchreiben)
                            Puffer=RSet(Puffer, 16, "0")     
                            Puffer="S"+Puffer+Chr(13)
                      EndSelect                      
                      WriteSerialPortData(Hcom,@Puffer,Len(Puffer))
                      ;Warte bis Daten vollstndig eingelaufen sind
                      tmp.s=WarteAufEnde(Hcom)
                      SetGadgetText(#frmHaupt_txtDatenLesen,tmp)
                      CloseSerialPort(Hcom)
                   EndIf
                Case #frmHaupt_cmdLesen
                   HCom=OpenSerialPort(#PB_Any, KommPara, 4800, #PB_SerialPort_NoParity, 8, 2, #PB_SerialPort_NoHandshake, 512, 512)
                   If Hcom 
                      SetzeKommandoModus(HCom)
                      Puffer.s = Hex(Val(GetGadgetText(#frmHaupt_txtBytes)))
                      If Len(Puffer)=1:Puffer="0"+Puffer:EndIf
                      If Len(Puffer)<>2:Puffer="FF":EndIf
                      Puffer="L"+Puffer+Chr(13)
                      WriteSerialPortData(Hcom,@Puffer,Len(Puffer))
                      ;Warte bis Daten vollstndig eingelaufen sind
                      tmp.s=WarteAufEnde(Hcom)
                      SetGadgetText(#frmHaupt_txtDatenLesen,tmp)
                      CloseSerialPort(Hcom)
                   EndIf
             EndSelect
       EndSelect
   Until Quit = 1
EndIf

;Programmeinstellungen speichern
Einstellungen(1)

End
; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 153
; Folding = A-
; EnableXP
; Executable = v24spk.exe
; CompileSourceDirectory
; Debugger = IDE
; EnableCompileCount = 74
; EnableBuildCount = 2
; EnableExeConstant